// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: botUser.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// BotUserClient is the client API for BotUser service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type BotUserClient interface {
	Create(ctx context.Context, in *BotUserModel, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *BotUserModel, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*BotUserModel, error)
	List(ctx context.Context, in *BotUserList, opts ...grpc.CallOption) (*BotUserListResp, error)
	Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error)
}

type botUserClient struct {
	cc grpc.ClientConnInterface
}

func NewBotUserClient(cc grpc.ClientConnInterface) BotUserClient {
	return &botUserClient{cc}
}

func (c *botUserClient) Create(ctx context.Context, in *BotUserModel, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.BotUser/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botUserClient) Update(ctx context.Context, in *BotUserModel, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.BotUser/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botUserClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.BotUser/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botUserClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*BotUserModel, error) {
	out := new(BotUserModel)
	err := c.cc.Invoke(ctx, "/botMs.BotUser/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botUserClient) List(ctx context.Context, in *BotUserList, opts ...grpc.CallOption) (*BotUserListResp, error) {
	out := new(BotUserListResp)
	err := c.cc.Invoke(ctx, "/botMs.BotUser/List", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botUserClient) Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error) {
	out := new(proto.UInt64Value)
	err := c.cc.Invoke(ctx, "/botMs.BotUser/Count", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// BotUserServer is the server API for BotUser service.
// All implementations must embed UnimplementedBotUserServer
// for forward compatibility
type BotUserServer interface {
	Create(context.Context, *BotUserModel) (*proto.IdRequest, error)
	Update(context.Context, *BotUserModel) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*BotUserModel, error)
	List(context.Context, *BotUserList) (*BotUserListResp, error)
	Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error)
	mustEmbedUnimplementedBotUserServer()
}

// UnimplementedBotUserServer must be embedded to have forward compatible implementations.
type UnimplementedBotUserServer struct {
}

func (UnimplementedBotUserServer) Create(context.Context, *BotUserModel) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedBotUserServer) Update(context.Context, *BotUserModel) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedBotUserServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedBotUserServer) Get(context.Context, *proto.IdRequest) (*BotUserModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedBotUserServer) List(context.Context, *BotUserList) (*BotUserListResp, error) {
	return nil, status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedBotUserServer) Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Count not implemented")
}
func (UnimplementedBotUserServer) mustEmbedUnimplementedBotUserServer() {}

// UnsafeBotUserServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to BotUserServer will
// result in compilation errors.
type UnsafeBotUserServer interface {
	mustEmbedUnimplementedBotUserServer()
}

func RegisterBotUserServer(s grpc.ServiceRegistrar, srv BotUserServer) {
	s.RegisterService(&BotUser_ServiceDesc, srv)
}

func _BotUser_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BotUserModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotUserServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.BotUser/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotUserServer).Create(ctx, req.(*BotUserModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _BotUser_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BotUserModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotUserServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.BotUser/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotUserServer).Update(ctx, req.(*BotUserModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _BotUser_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotUserServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.BotUser/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotUserServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _BotUser_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotUserServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.BotUser/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotUserServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _BotUser_List_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BotUserList)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotUserServer).List(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.BotUser/List",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotUserServer).List(ctx, req.(*BotUserList))
	}
	return interceptor(ctx, in, info, handler)
}

func _BotUser_Count_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotUserServer).Count(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.BotUser/Count",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotUserServer).Count(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// BotUser_ServiceDesc is the grpc.ServiceDesc for BotUser service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var BotUser_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.BotUser",
	HandlerType: (*BotUserServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _BotUser_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _BotUser_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _BotUser_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _BotUser_Get_Handler,
		},
		{
			MethodName: "List",
			Handler:    _BotUser_List_Handler,
		},
		{
			MethodName: "Count",
			Handler:    _BotUser_Count_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "botUser.proto",
}
